"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var I18nModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const i18n_constants_1 = require("./i18n.constants");
const i18n_service_1 = require("./services/i18n.service");
const parse_1 = require("./utils/parse");
const path = require("path");
const logger = new common_1.Logger('I18nService');
const defaultOptions = {
    filePattern: '*.json',
};
let I18nModule = I18nModule_1 = class I18nModule {
    static forRoot(options) {
        options = this.sanitizeI18nOptions(options);
        const i18nOptions = {
            provide: i18n_constants_1.I18N_OPTIONS,
            useValue: options,
        };
        const translationsProvider = {
            provide: i18n_constants_1.I18N_TRANSLATIONS,
            useFactory: () => __awaiter(this, void 0, void 0, function* () {
                try {
                    return yield parse_1.parseTranslations(options);
                }
                catch (e) {
                    return {};
                }
            }),
        };
        return {
            module: I18nModule_1,
            providers: [
                { provide: common_1.Logger, useValue: logger },
                i18n_service_1.I18nService,
                i18nOptions,
                translationsProvider,
            ],
            exports: [i18n_service_1.I18nService],
        };
    }
    static forRootAsync(options) {
        const asyncOptionsProvider = this.createAsyncOptionsProvider(options);
        const asyncTranslationProvider = this.createAsyncTranslationProvider();
        return {
            module: I18nModule_1,
            imports: options.imports || [],
            providers: [
                { provide: common_1.Logger, useValue: logger },
                asyncOptionsProvider,
                asyncTranslationProvider,
                i18n_service_1.I18nService,
            ],
            exports: [i18n_service_1.I18nService],
        };
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: i18n_constants_1.I18N_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            provide: i18n_constants_1.I18N_OPTIONS,
            useFactory: (optionsFactory) => __awaiter(this, void 0, void 0, function* () { return yield optionsFactory.createI18nOptions(); }),
            inject: [options.useClass || options.useExisting],
        };
    }
    static createAsyncTranslationProvider() {
        return {
            provide: i18n_constants_1.I18N_TRANSLATIONS,
            useFactory: (options) => __awaiter(this, void 0, void 0, function* () {
                options = this.sanitizeI18nOptions(options);
                try {
                    return yield parse_1.parseTranslations(options);
                }
                catch (e) {
                    return {};
                }
            }),
            inject: [i18n_constants_1.I18N_OPTIONS],
        };
    }
    static sanitizeI18nOptions(options) {
        options = Object.assign({}, defaultOptions, options);
        options.path = path.normalize(options.path + path.sep);
        if (!options.filePattern.startsWith('*.')) {
            options.filePattern = '*.' + options.filePattern;
        }
        return options;
    }
};
I18nModule = I18nModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({})
], I18nModule);
exports.I18nModule = I18nModule;
