"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const glob = require("glob");
const path = require("path");
const flat = require("flat");
const fs_1 = require("fs");
const isDirectory = source => fs_1.lstatSync(source).isDirectory();
const getDirectories = source => fs_1.readdirSync(source)
    .map(name => path.join(source, name))
    .filter(isDirectory);
function parseTranslations(options) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            const i18nPath = path.normalize(options.path + path.sep);
            const translations = {};
            if (!fs.existsSync(i18nPath)) {
                reject('i18n path does not exists');
            }
            const languages = getDirectories(i18nPath).map(dir => path.relative(i18nPath, dir));
            glob(i18nPath + '**/' + options.filePattern, (err, files) => {
                if (err) {
                    return reject(err);
                }
                files.map(file => {
                    let global = false;
                    const key = path
                        .dirname(path.relative(i18nPath, file))
                        .split(path.sep)[0];
                    if (key === '.') {
                        global = true;
                    }
                    const data = JSON.parse(fs.readFileSync(file, 'utf8'));
                    const flatData = flat.flatten(data);
                    for (const property of Object.keys(flatData)) {
                        [...(global ? languages : [key])].forEach(lang => {
                            translations[lang] = !!translations[lang]
                                ? translations[lang]
                                : {};
                            translations[lang][property] = flatData[property];
                        });
                    }
                });
                resolve(translations);
            });
        });
    });
}
exports.parseTranslations = parseTranslations;
